# Root level columns
SPAN_TRACE_ID_COL_NAME = "context.trace_id"
SPAN_SPAN_ID_COL_NAME = "context.span_id"
SPAN_PARENT_SPAN_ID_COL_NAME = "parent_id"
SPAN_NAME_COL_NAME = "name"
SPAN_START_TIME_COL_NAME = "start_time"
SPAN_END_TIME_COL_NAME = "end_time"
# Status columns
SPAN_STATUS_CODE_COL_NAME = "status_code"
SPAN_STATUS_MESSAGE_COL_NAME = "status_message"
# Events columns
SPAN_EVENTS_COL_NAME = "events"
# Attributes
ROOT_LEVEL_SPAN_KIND_COL_NAME = "span_kind"
SPAN_KIND_COL_NAME = "attributes.openinference.span.kind"
# Attributes Exception columns
SPAN_ATTRIBUTES_EXCEPTION_TYPE_COL_NAME = "attributes.exception.type"
SPAN_ATTRIBUTES_EXCEPTION_MESSAGE_COL_NAME = "attributes.exception.message"
SPAN_ATTRIBUTES_EXCEPTION_ESCAPED_COL_NAME = "attributes.exception.escaped"
SPAN_ATTRIBUTES_EXCEPTION_STACK_TRACE_COL_NAME = "attributes.exception.stacktrace"
# Attributes Input columns
SPAN_ATTRIBUTES_INPUT_VALUE_COL_NAME = "attributes.input.value"
SPAN_ATTRIBUTES_INPUT_MIME_TYPE_COL_NAME = "attributes.input.mime_type"
# Attributes Output columns
SPAN_ATTRIBUTES_OUTPUT_VALUE_COL_NAME = "attributes.output.value"
SPAN_ATTRIBUTES_OUTPUT_MIME_TYPE_COL_NAME = "attributes.output.mime_type"
# Attributes Embedding columns
SPAN_ATTRIBUTES_EMBEDDING_MODEL_NAME_COL_NAME = "attributes.embedding.model_name"
SPAN_ATTRIBUTES_EMBEDDING_EMBEDDINGS_COL_NAME = "attributes.embedding.embeddings"
# Embedding Object keys
SPAN_ATTRIBUTES_EMBEDDING_VECTOR_KEY = "embedding.vector"
SPAN_ATTRIBUTES_EMBEDDING_TEXT_KEY = "embedding.text"
# Attributes LLM columns
# SpanAttributesLLMFunctionCallColName            = "attributes.llm.function_call"
SPAN_ATTRIBUTES_LLM_MODEL_NAME_COL_NAME = "attributes.llm.model_name"
SPAN_ATTRIBUTES_LLM_INPUT_MESSAGES_COL_NAME = "attributes.llm.input_messages"
SPAN_ATTRIBUTES_LLM_OUTPUT_MESSAGES_COL_NAME = "attributes.llm.output_messages"
SPAN_ATTRIBUTES_LLM_INVOCATION_PARAMETERS_COL_NAME = "attributes.llm.invocation_parameters"
SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_TEMPLATE_COL_NAME = "attributes.llm.prompt_template.template"
SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VARIABLES_COL_NAME = "attributes.llm.prompt_template.variables"
SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VERSION_COL_NAME = "attributes.llm.prompt_template.version"
SPAN_ATTRIBUTES_LLM_PROMPT_TOKEN_COUNT_COL_NAME = "attributes.llm.token_count.prompt"
SPAN_ATTRIBUTES_LLM_COMPLETION_TOKEN_COUNT_COL_NAME = "attributes.llm.token_count.completion"
SPAN_ATTRIBUTES_LLM_TOTAL_TOKEN_COUNT_COL_NAME = "attributes.llm.token_count.total"
# Attributes Message Keys
SPAN_ATTRIBUTES_MESSAGE_ROLE_KEY = "message.role"
SPAN_ATTRIBUTES_MESSAGE_CONTENT_KEY = "message.content"
SPAN_ATTRIBUTES_MESSAGE_TOOL_CALLS_KEY = "message.tool_calls"
SPAN_ATTRIBUTES_MESSAGE_TOOL_CALLS_FUNCTION_NAME_KEY = "tool_call.function.name"
SPAN_ATTRIBUTES_MESSAGE_TOOL_CALLS_FUNCTION_ARGUMENTS_KEY = "tool_call.function.arguments"
# Attributes Tool columns
SPAN_ATTRIBUTES_TOOL_NAME_COL_NAME = "tool.name"
SPAN_ATTRIBUTES_TOOL_DESCRIPTION_COL_NAME = "tool.description"
SPAN_ATTRIBUTES_TOOL_PARAMETERS_COL_NAME = "tool.parameters"
# Attributes Retrieval columns
SPAN_ATTRIBUTES_RETRIEVAL_DOCUMENTS_COL_NAME = "attributes.retrieval.documents"
# Document Object Keys
SPAN_ATTRIBUTES_DOCUMENT_ID_KEY = "document.id"
SPAN_ATTRIBUTES_DOCUMENT_SCORE_KEY = "document.score"
SPAN_ATTRIBUTES_DOCUMENT_CONTENT_KEY = "document.content"
SPAN_ATTRIBUTES_DOCUMENT_METADATA_KEY = "document.metadata"
# Attributes Reranker columns
SPAN_ATTRIBUTES_RERANKER_INPUT_DOCUMENTS_COL_NAME = "attributes.reranker.input_documents"
SPAN_ATTRIBUTES_RERANKER_OUTPUT_DOCUMENTS_COL_NAME = "attributes.reranker.output_documents"
SPAN_ATTRIBUTES_RERANKER_QUERY_COL_NAME = "attributes.reranker.query"
SPAN_ATTRIBUTES_RERANKER_MODEL_NAME_COL_NAME = "attributes.reranker.model_name"
SPAN_ATTRIBUTES_RERANKER_TOP_K_COL_NAME = "attributes.reranker.top_k"

# TODO(Kiko): Add a test that checks no dupes in following lists
SPAN_OPEN_INFERENCE_COLUMN_NAMES = [
    SPAN_TRACE_ID_COL_NAME,
    SPAN_SPAN_ID_COL_NAME,
    SPAN_PARENT_SPAN_ID_COL_NAME,
    ROOT_LEVEL_SPAN_KIND_COL_NAME,
    SPAN_KIND_COL_NAME,
    SPAN_NAME_COL_NAME,
    SPAN_START_TIME_COL_NAME,
    SPAN_END_TIME_COL_NAME,
    SPAN_STATUS_CODE_COL_NAME,
    SPAN_STATUS_MESSAGE_COL_NAME,
    SPAN_EVENTS_COL_NAME,
    SPAN_ATTRIBUTES_EXCEPTION_TYPE_COL_NAME,
    SPAN_ATTRIBUTES_EXCEPTION_MESSAGE_COL_NAME,
    SPAN_ATTRIBUTES_EXCEPTION_ESCAPED_COL_NAME,
    SPAN_ATTRIBUTES_EXCEPTION_STACK_TRACE_COL_NAME,
    SPAN_ATTRIBUTES_INPUT_VALUE_COL_NAME,
    SPAN_ATTRIBUTES_INPUT_MIME_TYPE_COL_NAME,
    SPAN_ATTRIBUTES_OUTPUT_VALUE_COL_NAME,
    SPAN_ATTRIBUTES_OUTPUT_MIME_TYPE_COL_NAME,
    SPAN_ATTRIBUTES_EMBEDDING_MODEL_NAME_COL_NAME,
    SPAN_ATTRIBUTES_EMBEDDING_EMBEDDINGS_COL_NAME,
    SPAN_ATTRIBUTES_LLM_INVOCATION_PARAMETERS_COL_NAME,
    SPAN_ATTRIBUTES_LLM_INPUT_MESSAGES_COL_NAME,
    SPAN_ATTRIBUTES_LLM_OUTPUT_MESSAGES_COL_NAME,
    SPAN_ATTRIBUTES_LLM_MODEL_NAME_COL_NAME,
    SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_TEMPLATE_COL_NAME,
    SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VARIABLES_COL_NAME,
    SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VERSION_COL_NAME,
    SPAN_ATTRIBUTES_LLM_PROMPT_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_LLM_COMPLETION_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_LLM_TOTAL_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_TOOL_NAME_COL_NAME,
    SPAN_ATTRIBUTES_TOOL_DESCRIPTION_COL_NAME,
    SPAN_ATTRIBUTES_TOOL_PARAMETERS_COL_NAME,
    SPAN_ATTRIBUTES_RETRIEVAL_DOCUMENTS_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_INPUT_DOCUMENTS_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_OUTPUT_DOCUMENTS_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_QUERY_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_MODEL_NAME_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_TOP_K_COL_NAME,
]
# The following are helper lists to validate data types in the columns of the dataframe
# Any column missing from the lists below will be assumed to contain and rejected otherwise

# Columns with list of dictionaries in them
LIST_OF_DICT_COLS = [
    SPAN_ATTRIBUTES_EMBEDDING_EMBEDDINGS_COL_NAME,
    SPAN_ATTRIBUTES_LLM_INPUT_MESSAGES_COL_NAME,
    SPAN_ATTRIBUTES_LLM_OUTPUT_MESSAGES_COL_NAME,
    SPAN_ATTRIBUTES_RETRIEVAL_DOCUMENTS_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_INPUT_DOCUMENTS_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_OUTPUT_DOCUMENTS_COL_NAME,
    SPAN_EVENTS_COL_NAME,
]
# Columns with dictionaries in them
DICT_COLS = [
    SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VARIABLES_COL_NAME,
]
# Columns with JSON strings in them
JSON_STR_COLS = [
    SPAN_ATTRIBUTES_LLM_PROMPT_TEMPLATE_VARIABLES_COL_NAME,
    SPAN_ATTRIBUTES_TOOL_PARAMETERS_COL_NAME,
]
# Columns with numbers in them
NUM_COLS = [
    SPAN_ATTRIBUTES_LLM_PROMPT_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_LLM_COMPLETION_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_LLM_TOTAL_TOKEN_COUNT_COL_NAME,
    SPAN_ATTRIBUTES_RERANKER_TOP_K_COL_NAME,
]
# Columns with booleans in them
BOOL_COLS = [
    SPAN_ATTRIBUTES_EXCEPTION_ESCAPED_COL_NAME,
]
# Columns with times in them in many different format
TIME_COLS = [
    SPAN_START_TIME_COL_NAME,
    SPAN_END_TIME_COL_NAME,
]
